<?php
namespace Etsoftware\Lib;

/**
 * 汽车车牌识别
 */
class Car
{
    private $data = array(
        "云A" => "昆明市"
        , "云A-V" => "东川市"
        , "云C" => "昭通市"
        , "云D" => "曲靖市"
        , "云E" => "楚雄彝族"
        , "云F" => "玉溪市"
        , "云G" => "红河哈尼族彝族自治州"
        , "云H" => "文山壮族苗族自治州"
        , "云J" => "思茅市"
        , "云K" => "西双版纳傣族自治州"
        , "云L" => "大理白族自治州"
        , "云M" => "保山市"
        , "云N" => "德宏傣族景颇族自治州"
        , "云P" => "丽江市"
        , "云Q" => "怒江僳族自治州"
        , "云R" => "迪庆藏族自治州"
        , "云S" => "临沧地区"
        , "京A" => "北京市（城区）"
        , "京B" => "北京市（出租车）"
        , "京C" => "北京市（城区）"
        , "京E" => "北京市（城区）"
        , "京F" => "北京市（城区）"
        , "京G" => "北京市(远郊区)"
        , "冀A" => "石家庄市"
        , "冀B" => "唐山市"
        , "冀C" => "秦皇岛市"
        , "冀D" => "邯郸市"
        , "冀E" => "刑台市"
        , "冀F" => "保定市"
        , "冀G" => "张家口市"
        , "冀H" => "承德市"
        , "冀J" => "沧州市"
        , "冀R" => "廊坊市"
        , "冀S" => "沧州市"
        , "冀T" => "衡水市"
        , "辽F" => "丹东市"
        , "台A" => "台北市"
        , "台B" => "高雄市"
        , "台C" => "台中市"
        , "台D" => "台南市"
        , "台E" => "基隆市"
        , "台F" => "新竹市"
        , "台G" => "嘉义市"
        , "吉A" => "长春市"
        , "吉B" => "吉林市"
        , "吉C" => "四平市"
        , "吉D" => "辽源市"
        , "吉E" => "通化市"
        , "吉F" => "白山市"
        , "吉G" => "白城市"
        , "吉H" => "延边朝鲜族自治州"
        , "吉J" => "松原市"
        , "宁A" => "银川市"
        , "宁B" => "石嘴山市"
        , "宁C" => "银南市"
        , "宁D" => "固原市"
        , "宁E" => "中卫市"
        , "川A" => "成都市"
        , "川B" => "绵阳市"
        , "川C" => "自贡市"
        , "川D" => "攀枝花市"
        , "川E" => "泸州市"
        , "川F" => "德阳市"
        , "川H" => "广元市"
        , "川J" => "遂宁市"
        , "川K" => "内江市"
        , "川L" => "乐山市"
        , "川M" => "资阳市"
        , "川N" => "涪陵"
        , "川P" => "黔江行署"
        , "川Q" => "宜宾市"
        , "川R" => "南充市"
        , "川S" => "达州市"
        , "川T" => "雅安市"
        , "川U" => "阿坝藏族羌族自治州"
        , "川V" => "甘孜藏族自治州"
        , "川W" => "凉山彝族自治州"
        , "川X" => "广安市"
        , "川Y" => "巴中市"
        , "川Z" => "眉山市"
        , "新A" => "乌鲁木齐市"
        , "新B" => "昌吉回族自治州"
        , "新C" => "石河子市"
        , "新D" => "奎屯市"
        , "新E" => "博尔塔拉蒙古自治州"
        , "新F" => "伊犁哈萨克自治州"
        , "新G" => "塔城市"
        , "新H" => "阿勒泰市"
        , "新J" => "克拉玛依市"
        , "新K" => "吐鲁番市"
        , "新L" => "哈密市"
        , "新M" => "巴音郭愣蒙古自治州"
        , "新N" => "阿克苏市"
        , "新P" => "克孜勒苏柯尔克孜自治州"
        , "新Q" => "喀什市"
        , "新R" => "和田市"
        , "晋A" => "太原市"
        , "晋B" => "大同市"
        , "晋C" => "阳泉市"
        , "晋D" => "长治市"
        , "晋E" => "晋城市"
        , "晋F" => "朔州市"
        , "晋G" => "雁北地区"
        , "晋H" => "忻州市"
        , "晋J" => "吕梁地区"
        , "晋K" => "晋中市"
        , "晋L" => "临汾市"
        , "晋M" => "运城市"
        , "桂A" => "南宁市"
        , "桂B" => "柳州市"
        , "桂C" => "桂林市"
        , "桂D" => "梧州市"
        , "桂E" => "北海市"
        , "桂F" => "南宁地区"
        , "桂G" => "柳州地区"
        , "桂H" => "桂林地区"
        , "桂J" => "梧州市"
        , "桂K" => "玉林市"
        , "桂L" => "百色市"
        , "桂M" => "河池市"
        , "桂N" => "钦州市"
        , "桂P" => "防城港市"
        , "沪A" => "上海市"
        , "沪B" => "上海市"
        , "沪C" => "上海市（远郊区）"
        , "沪D" => "上海市"
        , "沪R" => "崇明、长兴、横沙"
        , "津A" => "天津市"
        , "津B" => "天津市"
        , "津C" => "天津市"
        , "津E" => "天津市（出租车）"
        , "浙A" => "杭州市"
        , "浙B" => "宁波市"
        , "浙C" => "温州市"
        , "浙D" => "绍兴市"
        , "浙E" => "湖州市"
        , "浙F" => "嘉兴市"
        , "浙G" => "金华市"
        , "浙H" => "衢州市"
        , "浙J" => "台州市"
        , "浙K" => "丽水市"
        , "浙L" => "舟山市"
        , "渝A" => "重庆市区（江南）"
        , "渝B" => "重庆市区（江北）"
        , "渝C" => "永川区"
        , "渝F" => "万州区"
        , "渝G" => "涪陵区"
        , "渝H" => "黔江区"
        , "港A" => "香港"
        , "湘A" => "长沙市"
        , "湘B" => "株州市"
        , "湘C" => "湘潭市"
        , "湘D" => "衡阳市"
        , "湘E" => "邵阳市"
        , "湘F" => "岳阳市"
        , "湘G" => "张家界市"
        , "湘H" => "益阳市"
        , "湘J" => "常德市"
        , "湘K" => "娄底市"
        , "湘L" => "郴州市"
        , "湘M" => "永州市"
        , "湘N" => "怀化市"
        , "湘U" => "湘西土家族苗族自治州"
        , "澳A" => "澳门"
        , "琼A" => "海口市"
        , "琼B" => "三亚市"
        , "琼C" => "琼海市"
        , "琼D" => "五指山市"
        , "琼E" => "洋浦开发区"
        , "甘A" => "兰州市"
        , "甘B" => "嘉峪关市"
        , "甘C" => "金昌市"
        , "甘D" => "白银市"
        , "甘E" => "天水市"
        , "甘F" => "洒泉市"
        , "甘G" => "张掖市"
        , "甘H" => "武威市"
        , "甘J" => "定西市"
        , "甘K" => "陇南市"
        , "甘L" => "平凉市"
        , "甘M" => "庆阳市"
        , "甘N" => "临夏回族"
        , "甘P" => "甘南藏族"
        , "皖A" => "合肥市"
        , "皖B" => "芜湖市"
        , "皖C" => "蚌埠市"
        , "皖D" => "淮南市"
        , "皖E" => "马鞍山市"
        , "皖F" => "淮北市"
        , "皖G" => "铜陵市"
        , "皖H" => "安庆市"
        , "皖J" => "黄山市"
        , "皖K" => "阜阳市"
        , "皖L" => "宿县市"
        , "皖M" => "滁州市"
        , "皖N" => "六安市"
        , "皖P" => "宜城市"
        , "皖Q" => "巢湖市"
        , "皖R" => "池州市"
        , "皖S" => "亳州市"
        , "粤A" => "广州市"
        , "粤B" => "深圳市"
        , "粤C" => "珠海市"
        , "粤D" => "汕头市"
        , "粤E" => "佛山市"
        , "粤F" => "韶关市"
        , "粤G" => "湛江市"
        , "粤H" => "肇庆市"
        , "粤J" => "江门市"
        , "粤K" => "茂名市"
        , "粤L" => "惠州市"
        , "粤M" => "梅州市"
        , "粤N" => "汕尾市"
        , "粤P" => "河源市"
        , "粤Q" => "阳江市"
        , "粤R" => "清远市"
        , "粤S" => "东莞市"
        , "粤T" => "中山市"
        , "粤U" => "潮州市"
        , "粤V" => "揭阳市"
        , "粤W" => "云浮市"
        , "粤X" => "顺德市"
        , "粤Y" => "南海市"
        , "粤Z" => "港澳进入内地车辆"
        , "苏A" => "南京市"
        , "苏B" => "无锡市"
        , "苏C" => "徐州市"
        , "苏D" => "常州市"
        , "苏E" => "苏州市"
        , "苏F" => "南通市"
        , "苏G" => "连云港市"
        , "苏H" => "淮安市"
        , "苏J" => "盐城市"
        , "苏K" => "扬州市"
        , "苏L" => "镇江市"
        , "苏M" => "泰州市"
        , "苏N" => "宿迁市"
        , "蒙A" => "呼和浩特市"
        , "蒙B" => "包头市"
        , "蒙C" => "乌海市"
        , "蒙D" => "赤峰市"
        , "蒙E" => "呼伦贝尔市"
        , "蒙F" => "兴安盟"
        , "蒙G" => "通辽市"
        , "蒙H" => "锡林郭勒盟"
        , "蒙J" => "乌兰察布盟"
        , "蒙K" => "鄂尔多斯市"
        , "蒙L" => "巴彦淖尔盟"
        , "蒙M" => "阿拉善盟"
        , "藏A" => "拉萨市"
        , "藏B" => "昌都地区"
        , "藏C" => "山南地区"
        , "藏D" => "日喀则地区"
        , "藏E" => "那曲地区"
        , "藏F" => "阿里地区"
        , "藏G" => "林芝地区"
        , "豫A" => "郑州市"
        , "豫B" => "开封市"
        , "豫C" => "洛阳市"
        , "豫D" => "平顶山市"
        , "豫E" => "安阳市"
        , "豫F" => "鹤壁市"
        , "豫G" => "新乡市"
        , "豫H" => "焦作市"
        , "豫J" => "濮阳市"
        , "豫K" => "许昌市"
        , "豫L" => "漯河市"
        , "豫M" => "三门峡市"
        , "豫N" => "商丘市"
        , "豫P" => "周口市"
        , "豫Q" => "驻马店市"
        , "豫R" => "南阳市"
        , "豫S" => "信阳市"
        , "豫U" => "济源市"
        , "贵A" => "贵阳市"
        , "贵B" => "六盘水市"
        , "贵C" => "遵义市"
        , "贵D" => "铜仁市"
        , "贵E" => "黔西南布依族苗族自治州"
        , "贵F" => "毕节市"
        , "贵G" => "安顺市"
        , "贵H" => "黔东南苗族侗族自治州"
        , "贵J" => "黔南布依族苗族自治州"
        , "赣A" => "南昌市"
        , "赣B" => "赣州市"
        , "赣C" => "宜春市"
        , "赣D" => "吉安市"
        , "赣E" => "上饶市"
        , "赣F" => "抚州市"
        , "赣G" => "九江市"
        , "赣H" => "景德镇市"
        , "赣J" => "萍乡市"
        , "赣K" => "新余市"
        , "赣L" => "鹰潭市"
        , "赣M" => "南昌市"
        , "辽A" => "沈阳市"
        , "辽B" => "大连市"
        , "辽C" => "鞍山市"
        , "辽D" => "抚顺市"
        , "辽E" => "本溪市"
        , "辽G" => "锦州市"
        , "辽H" => "营口市"
        , "辽J" => "阜新市"
        , "辽K" => "辽阳市"
        , "辽L" => "盘锦市"
        , "辽M" => "铁岭市"
        , "辽N" => "朝阳市"
        , "辽P" => "葫芦岛市"
        , "鄂A" => "武汉市"
        , "鄂B" => "黄石市"
        , "鄂C" => "十堰市"
        , "鄂D" => "荆州市"
        , "鄂E" => "宜昌市"
        , "鄂F" => "襄樊市"
        , "鄂G" => "鄂州市"
        , "鄂H" => "荆门市"
        , "鄂J" => "黄冈市"
        , "鄂K" => "孝感市"
        , "鄂L" => "咸宁市"
        , "鄂M" => "仙桃市"
        , "鄂N" => "潜江市"
        , "鄂P" => "神农架林区"
        , "鄂Q" => "恩施土家族苗族自治州"
        , "鄂R" => "天门市"
        , "鄂S" => "随州市"
        , "闽A" => "福州市"
        , "闽B" => "莆田市"
        , "闽C" => "泉州市"
        , "闽D" => "厦门市"
        , "闽E" => "漳州市"
        , "闽F" => "龙岩市"
        , "闽G" => "三明市"
        , "闽H" => "南平市"
        , "闽J" => "宁德市"
        , "闽K" => "省直系统"
        , "陕A" => "西安市"
        , "陕B" => "铜川市"
        , "陕C" => "宝鸡市"
        , "陕D" => "威阳市"
        , "陕E" => "渭南市"
        , "陕F" => "汉中市"
        , "陕G" => "安康市"
        , "陕H" => "商洛市"
        , "陕J" => "延安市"
        , "陕K" => "榆林市"
        , "陕V" => "杨凌"
        , "青A" => "西宁市"
        , "青B" => "海东市"
        , "青C" => "海北藏族自治州"
        , "青D" => "黄南藏族自治州"
        , "青E" => "海南藏族自治州"
        , "青F" => "果洛藏族自治州"
        , "青G" => "玉树藏族自治州"
        , "青H" => "海西蒙古族藏族自治州"
        , "鲁A" => "济南市"
        , "鲁B" => "青岛市"
        , "鲁C" => "淄博市"
        , "鲁D" => "枣庄市"
        , "鲁E" => "东营市"
        , "鲁F" => "烟台市"
        , "鲁G" => "潍坊市"
        , "鲁H" => "济宁市"
        , "鲁J" => "泰安市"
        , "鲁K" => "威海市"
        , "鲁L" => "日照市"
        , "鲁M" => "滨州市"
        , "鲁N" => "德州市"
        , "鲁P" => "聊城市"
        , "鲁Q" => "临沂市"
        , "鲁R" => "荷泽市"
        , "鲁S" => "莱芜市"
        , "鲁U" => "青岛市增补"
        , "鲁V" => "潍坊市增补"
        , "黑A" => "哈尔滨市"
        , "黑B" => "齐齐哈尔市"
        , "黑C" => "牡丹江市"
        , "黑D" => "佳木斯市"
        , "黑E" => "大庆市"
        , "黑F" => "伊春市"
        , "黑G" => "鸡西市"
        , "黑H" => "鹤岗市"
        , "黑J" => "双鸭山市"
        , "黑K" => "七台河市"
        , "黑L" => "松花江地区（已并入哈尔滨市，车牌未改）"
        , "黑M" => "绥化市"
        , "黑N" => "黑河市"
        , "黑P" => "大兴安岭行"
        , "黑R" => "农恳系统"        
    );
    private $shortName = array(
        "云" => "云南"
        , "京" => "北京"
        , "冀" => "河北"
        , "台" => "台湾"
        , "吉" => "吉林"
        , "宁" => "宁夏"
        , "川" => "四川"
        , "广" => "广东"
        , "新" => "新疆"
        , "晋" => "山西"
        , "桂" => "广西"
        , "沪" => "上海"
        , "津" => "天津"
        , "浙" => "浙江"
        , "渝" => "重庆"
        , "港" => "香港"
        , "湘" => "湖南"
        , "澳" => "澳门"
        , "琼" => "海南"
        , "甘" => "甘肃"
        , "皖" => "安徽"
        , "粤" => "广东"
        , "苏" => "江苏"
        , "蒙" => "蒙古"
        , "藏" => "西藏"
        , "豫" => "河南"
        , "贵" => "贵州"
        , "赣" => "江西"
        , "辽" => "辽宁"
        , "鄂" => "湖北"
        , "闽" => "福建"
        , "陕" => "陕西"
        , "青" => "青海"
        , "鲁" => "山东"
        , "黑" => "黑龙江"        
    );
    private $extdata = array(
        array(
            array(
                 "v" => "军委、四总部、大区级直属单位"
                , "k" => "空军"
                , "h" => "海军"
                , "b" => "北京军区"
                , "s" => "沈阳军区"
                , "l" => "兰州军区"
                , "j" => "济南军区"
                , "n" => "南京军区"
                , "g" => "广州军区"
                , "c" => "成都军区"
            )
            , array(
                "a" => "司令部"
                , "b" => "政治部"
                , "c" => "后勤、联勤部"
                , "d" => "装备部"
                , "k" => "省军区、卫戍区"
                , "o" => "军车监理"
                , "r" => "院校"
                , "t" => "情报机构"
                , "v" => "战略导弹部队"
                , "y" => "野战部队"            
            )
        )
    );
    function __construct()
    {
        foreach($this->extdata as $v){
            foreach($v[0] as $k1=>$v1){
                foreach($v[1] as $k2=>$v2){
                    $this->data[strtoupper($k1.$k2)]= $v1.$v2;
                }
            }
        }
    }
    private function encode($id){}
    private function decode($id){
        $pre = "";
        foreach($this->shortName as $k=>$v){
            $pre .= "|$k";
        }
        $pre = substr($pre, 1);
        if(!preg_match("/(($pre)|([A-Z]))([A-Z])([\dA-Z]{5,6})/im", $id, $m))
            return null;
        return array(
            "shortname" => $m[1]
            , "pre" => $m[1].$m[4]
            , "number" => $m[5]
        );
    }
    private function isSmallEV($id){
        $data = $this->decode($id);
        if(!$data) return false;
        return preg_match("/^(D|A|B|C|E)[\dA-Z]{5}/im", $data['number']);
    }
    private function isBigEV($id){
        $data = $this->decode($id);
        if(!$data) return false;
        return preg_match("/^[\dA-Z]{5}(D|A|B|C|E)/im", $data['number']);
    }
    public function isEV($id){return isSmallEV($id) || isBigEV($id); }

    private function isSmallHEV($id){
        $data = $this->decode($id);
        if(!$data) return false;
        return preg_match("/^(F|G|H|J|K)[\dA-Z]{5}/im", $data['number']);
    }
    private function isBigHEV($id){
        $data = $this->decode($id);
        if(!$data) return false;
        return preg_match("/^[\dA-Z]{5}(F|G|H|J|K)/im", $data['number']);
    }
    public function isHEV($id){return isSmallHEV($id) || isBigHEV($id); }
    public function getType($id){
        if($this->isSmallEV($id))return "小型新能源汽车 纯电动汽车";
        if($this->isBigEV($id))return "大型新能源汽车 纯电动汽车";
        if($this->isSmallHEV($id))return "小型新能源汽车 非纯电动汽车";
        if($this->isBigHEV($id))return "大型新能源汽车 非纯电动汽车";
        if($this->isBigHEV($id))return "大型新能源汽车 非纯电动汽车";
        return "未知";
    }
    public function get($id){
        $id = strtoupper($id);
        $id = preg_replace("/[\s\.]+/im", "", $id);
        $data = $this->decode($id);
        $area = "";
        if($data){
            $area = $this->shortName[$data['shortname']]??"";
            $area .= $this->data[$data['pre']]??"";
        }
        $type = $this->getType($id);
        return array(
            'number' => $data['pre']." ".$data['number']
            , 'area' => $area
            , 'type' => $type
        );
    }

}